<?php

/*
 * CUSTOM ELEMENTS function library
 * (C) 2012 - David Cramer
 */

$Element = false;
$footerOutput = '';
$headerscripts = '';

function ce_process() {
    global $footerOutput, $headerscripts;

    if(!empty($_FILES['import'])){
        $preData = file_get_contents($_FILES['import']['tmp_name']);
        unlink($_FILES['import']['tmp_name']);
        $Data = unserialize(base64_decode($preData));
        ce_saveElement(stripslashes_deep($Data));
        wp_safe_redirect('?page=my_shortcode');
        exit;

    }

    if (!empty($_GET['export'])) {
        ce_exportElement($_GET['export']);
        exit();
    }

    if (!empty($_POST['data'])) {
        if(!wp_verify_nonce($_POST['_wpnonce'],'cs-edit-shortcode')){
            return;
        }
        ce_saveElement(stripslashes_deep($_POST['data']));
        wp_safe_redirect('?page=my_shortcode');
        exit;
    }
    
    //return;
    $url = url_to_postid($_SERVER['REQUEST_URI']);
    $post = get_post($url);
    if (empty($post)) {
        return;
    }

    preg_match_all('/' . get_shortcode_regex() . '/s', $post->post_content, $used);

    $elements = get_option('CE_ELEMENTS');
    foreach ($elements as $element => $options) {
        if(!empty($options['shortcode'])){
            if (in_array($options['shortcode'], $used[2])) {
                $shortcodes[] = $element;
            }
        }
    }
    if(empty($shortcodes)){
        return;
    }
    foreach ($shortcodes as $ID) {
        $Element = get_option($ID);

        if (!empty($Element['_jsLib'])) {
            foreach ($Element['_jsLib'] as $handle => $src) {
                $in_footer = false;
                if ($Element['_jsLibLoc'][$handle] == 2) {
                    $in_footer = true;
                }
                wp_register_script($handle, $src, false, false, $in_footer);
                wp_enqueue_script($handle);
            }
        }
        if (!empty($Element['_cssLib'])) {
            foreach ($Element['_cssLib'] as $handle => $src) {
                wp_enqueue_style($handle, $src);
            }
        }

        if (!empty($Element['_javascriptCode'])) {
            $footerOutput .= "
            " . $Element['_javascriptCode'] . "
            ";
        }

        if (!empty($Element['_cssCode'])) {
            $headerscripts .= "
            " . $Element['_cssCode'] . "
            ";
        }

        if (!empty($Element['_phpCode'])) {
            eval($Element['_phpCode']);
        }

    }
}

function ce_start() {
    if(!is_admin()){
        ce_styles();
        ce_scripts();
    }
}

function ce_header() {    
    global $headerscripts;   

    if(!empty($headerscripts)){
        echo "<style>\n";
            echo $headerscripts;
        echo "</style>\n";
    }
}
function ce_footer() {
    global $footerOutput;
    if(!empty($footerOutput)){
        echo "<script>\n";
        echo "jQuery(document).ready(function($) {\n";
        echo $footerOutput;
        echo "});\n";
        echo "</script>\n";
    }
}

function ce_menus() {

    add_menu_page("Shortcode Builder", "My Shortcodes", 'activate_plugins', "my_shortcode", "ce_adminPage");
    $adminPage = add_submenu_page("my_shortcode", 'My Shortcodes', 'Shortcode Builder', 'activate_plugins', "my_shortcode", 'ce_adminPage');

    add_action('admin_print_styles-' . $adminPage, 'ce_styles');
    add_action('admin_print_scripts-' . $adminPage, 'ce_scripts');
}

function ce_styles() {
    
    wp_register_style('ce_adminStyle', ELEMENTS_URL . 'styles/core.css');
    wp_enqueue_style('ce_adminStyle');

    if (!empty($_GET['action'])) {
        wp_enqueue_style('codemirror', ELEMENTS_URL . 'codemirror/lib/codemirror.css', false);
        wp_enqueue_style('codemirror-theme-cobalt', ELEMENTS_URL . 'codemirror/theme/cobalt.css', false);
        wp_enqueue_style('codemirror-theme-eclipse', ELEMENTS_URL . 'codemirror/theme/eclipse.css', false);
        wp_enqueue_style('codemirror-theme-elegant', ELEMENTS_URL . 'codemirror/theme/elegant.css', false);
        wp_enqueue_style('codemirror-theme-monokai', ELEMENTS_URL . 'codemirror/theme/monokai.css', false);
        wp_enqueue_style('codemirror-theme-neat', ELEMENTS_URL . 'codemirror/theme/neat.css', false);
        wp_enqueue_style('codemirror-theme-night', ELEMENTS_URL . 'codemirror/theme/night.css', false);
        wp_enqueue_style('codemirror-theme-rubyblue', ELEMENTS_URL . 'codemirror/theme/rubyblue.css', false);
        wp_enqueue_style('codemirror-simple-hint', ELEMENTS_URL . 'codemirror/lib/util/simple-hint.css', false);
        wp_enqueue_style('codemirror-dialog-css', ELEMENTS_URL . 'codemirror/lib/util/dialog.css', false);
    }
}

function ce_scripts() {

    wp_enqueue_script("jquery");
    if (!empty($_GET['action'])) {
        wp_enqueue_script('codemirror', ELEMENTS_URL . 'codemirror/lib/codemirror.js', false);
        wp_enqueue_script('codemirror-mode-css', ELEMENTS_URL . 'codemirror/mode/css/css.js', false);
        wp_enqueue_script('codemirror-mode-js', ELEMENTS_URL . 'codemirror/mode/javascript/javascript.js', false);
        wp_enqueue_script('codemirror-mode-xml', ELEMENTS_URL . 'codemirror/mode/xml/xml.js', false);
        wp_enqueue_script('codemirror-mode-clike', ELEMENTS_URL . 'codemirror/mode/clike/clike.js', false);
        wp_enqueue_script('codemirror-mode-php', ELEMENTS_URL . 'codemirror/mode/php/php.js', false);
        wp_enqueue_script('codemirror-mode-htmlmixed', ELEMENTS_URL . 'codemirror/mode/htmlmixed/htmlmixed.js', false);
        wp_enqueue_script('codemirror-simple-hint-js', ELEMENTS_URL . 'codemirror/lib/util/simple-hint.js', false);
        wp_enqueue_script('codemirror-js-hint', ELEMENTS_URL . 'codemirror/lib/util/javascript-hint.js', false);
        wp_enqueue_script('codemirror-dialog-js', ELEMENTS_URL . 'codemirror/lib/util/dialog.js', false);
        wp_enqueue_script('codemirror-searchcursor-js', ELEMENTS_URL . 'codemirror/lib/util/searchcursor.js', false);
        wp_enqueue_script('codemirror-search-js', ELEMENTS_URL . 'codemirror/lib/util/search.js', false);
    }
}

function ce_adminPage() {
    if (!empty($_GET['action'])) {
        switch ($_GET['action']) {

            case 'edit':
                include ELEMENTS_PATH . 'edit.php';
                break;
            default:
                include ELEMENTS_PATH . 'admin.php';
                break;
        }
    } else {
        include ELEMENTS_PATH . 'admin.php';
    }
}

function ce_configOption($ID, $Name, $Type, $Title, $Config) {

    $Return = '';

    switch ($Type) {
        case 'hidden':
            $Val = '';
            if (!empty($Config['_' . $Name])) {
                $Val = $Config['_' . $Name];
            }
            $Return .= '<input type="hidden" name="data[_' . $Name . ']" id="' . $ID . '" value="' . $Val . '" />';
            break;
        case 'textfield':
            $Val = '';
            if (!empty($Config['_' . $Name])) {
                $Val = $Config['_' . $Name];
            }
            $Return .= $Title . ' <input type="textfield" name="data[_' . $Name . ']" id="' . $ID . '" value="' . $Val . '" />';
            break;
        case 'textarea':
            $Val = '';
            if (!empty($Config['_' . $Name])) {
                $Val = $Config['_' . $Name];
            }
            $Return .= $Title . ' <textarea name="data[_' . $Name . ']" id="' . $ID . '" cols="70" rows="25">' . htmlentities($Val) . '</textarea>';
            break;
        case 'radio':
            $parts = explode('|', $Title);
            $options = explode(',', $parts[1]);
            $Return .= $parts[0];
            $index = 1;
            foreach ($options as $option) {
                $sel = '';
                if (!empty($Config['_' . $Name])) {
                    if ($Config['_' . $Name] == $index) {
                        $sel = 'checked="checked"';
                    }
                }
                if (empty($Config)) {
                    if ($index === 1) {
                        $sel = 'checked="checked"';
                    }
                }

                $Return .= ' <input type="radio" name="data[_' . $Name . ']" id="' . $ID . '_' . $index . '" value="' . $index . '" ' . $sel . '/> <label for="' . $ID . '_' . $index . '">' . $option . '</label>';
                $index++;
            }
            break;
    }

    return '<div class="ce_configOption">' . $Return . '</div>';
}

function ce_saveElement($Data) {

    if (empty($Data['_ID'])) {
        $Data['_ID'] = strtoupper(uniqid('EL'));
    }
    if (empty($Data['_name'])) {
        $Data['_name'] = $Data['_ID'];
    }
    if (empty($Data['_category'])) {
        $Data['_category'] = 'Ungrouped';
    }

    $elements = get_option('CE_ELEMENTS');
    $elements[$Data['_ID']]['name'] = $Data['_name'];
    $elements[$Data['_ID']]['category'] = $Data['_category'];
    if (!empty($Data['_shortcode'])) {
        $Data['_shortcode'] = sanitize_key($Data['_shortcode']);
        $elements[$Data['_ID']]['shortcode'] = $Data['_shortcode'];
    }
    $elements[$Data['_ID']]['codeType'] = $Data['_shortcodeType'];
    if (!empty($Data['_variable'])) {
        foreach ($Data['_variable'] as $Key => $Varible) {
            $Data['_variable'][$Key] = sanitize_key($Varible);
        }
        $elements[$Data['_ID']]['variables']['names'] = $Data['_variable'];
        $elements[$Data['_ID']]['variables']['defaults'] = $Data['_variableDefault'];
        $elements[$Data['_ID']]['variables']['info'] = $Data['_variableInfo'];
    } else {
        unset($elements[$Data['_ID']]['variables']);
    }

    update_option($Data['_ID'], $Data);
    update_option('CE_ELEMENTS', $elements);

    return true;
}

function ce_doShortcode($atts, $content, $shortcode) {

    global $footerOutput;

    $elements = get_option('CE_ELEMENTS');
    foreach ($elements as $id => $element) {
        if (!empty($element['shortcode'])) {
            if ($element['shortcode'] === $shortcode) {
                break;
            }
        }
    }
    if (empty($id)) {
        return;
    }
    $Element = get_option($id);

    $Element['_mainCode'] = str_replace('{{content}}', $content, $Element['_mainCode']);
    $pattern = '\[(\[?)(loop)\b([^\]\/]*(?:\/(?!\])[^\]\/]*)*?)(?:(\/)\]|\](?:([^\[]*+(?:\[(?!\/\2\])[^\[]*+)*+)\[\/\2\])?)(\]?)';
    preg_match_all('/' . $pattern . '/s', $Element['_mainCode'], $loops);

    if (!empty($loops)) {
        foreach ($loops[0] as $loopKey => $loopcode) {
            if (!empty($loops[3][$loopKey])) {
                $LoopCodes[$loopKey] = $loops[5][$loopKey];
                $Element['_mainCode'] = str_replace($loopcode, '{{__loop_' . $loopKey . '_}}', $Element['_mainCode']);
            }
        }
    }
    if (!empty($Element['_variable'])) {
        foreach ($Element['_variable'] as $VarKey => $Variable) {
            $VarVal = $Element['_variableDefault'][$VarKey];
            if (!empty($atts[$Variable])) {
                $VarVal = $atts[$Variable];
            }
            if (!empty($atts[$Variable . '_1'])) {
                $startcounter = true;
                $index = 1;
                while ($startcounter == true) {
                    if (!empty($atts[$Variable . '_' . $index])) {
                        $varArray[trim($Variable)][] = $atts[$Variable . '_' . $index];
                    } else {
                        $startcounter = false;
                    }
                    $index++;
                }
            }


            $Element['_mainCode'] = str_replace('{{' . $Variable . '}}', $VarVal, $Element['_mainCode']);
        }
        if (!empty($LoopCodes) && !empty($varArray)) {
            foreach ($LoopCodes as $loopKey => $loopCode) {
                $loopReplace = '';
                if (!empty($varArray[trim($loops[3][$loopKey])])) {
                    foreach ($varArray[trim($loops[3][$loopKey])] as $replaceKey => $replaceVar) {
                        $loopReplace .= $loopCode;
                        foreach ($varArray as $Variable => $VarableArray) {
                            if (!empty($varArray[$Variable][$replaceKey])) {
                                $loopReplace = str_replace('{{' . $Variable . '}}', $varArray[$Variable][$replaceKey], $loopReplace);
                            } else {
                                $loopReplace = str_replace('{{' . $Variable . '}}', '', $loopReplace);
                            }
                            $loopReplace = str_replace('[increment]', $replaceKey, $loopReplace);
                        }
                    }
                    $Element['_mainCode'] = str_replace('{{__loop_' . $loopKey . '_}}', $loopReplace, $Element['_mainCode']);
                }
            }
        }
    }

    ob_start();    
    eval(' ?>' . $Element['_mainCode'] . ' <?php ');
    $Output = ob_get_clean();
    $Output = str_replace("\r\n", "", $Output);
    $Output = str_replace("\r", "", $Output);
    $Output = str_replace("\n", "", $Output);

    return do_shortcode($Output);
}

if(is_admin ()){

    function ce_deleteElement() {

            $EID = $_POST['EID'];

            $Elements = get_option('CE_ELEMENTS');
            delete_option($EID);
            unset($Elements[$EID]);
            update_option('CE_ELEMENTS', $Elements);
            echo true;
            die();
    }
    function ce_applyElement() {
            parse_str(stripslashes($_POST['formData']), $Data);
            $Data = stripslashes_deep($Data);
            if(!empty($Data['data']['_ID'])){
                ce_saveElement($Data['data']);
            }
            die();
    }

    function ce_ajax_javascript() {
    ?>
    <script type="text/javascript" >
        function ce_deleteElement(eid){
            //if(confirm('Are you sure?')){
                var data = {
                        action: 'delete_element',
                        EID: eid
                };
                jQuery.post(ajaxurl, data, function(response) {
                        if(response == 1){
                            jQuery('#element_'+eid).slideUp('fast', function(){
                                jQuery('#element_'+eid).remove();
                                jQuery('.current .cs-elementCount').html(parseFloat(jQuery('.current .cs-elementCount').html()-1));
                            });
                        }
                });
            //}else{
            //    jQuery('.buttons_'+eid).slideToggle();
            //}
        }
        function ce_applyElement(eid){
                jQuery('#saveIndicator').slideDown(100);
                var data = {
                        action: 'apply_element',
                        EID: eid,
                        formData: jQuery('#elementEditForm').serialize()
                };
                
                jQuery.post(ajaxurl, data, function(response) {
                    jQuery('#saveIndicator').slideUp(100);
                });

        }
    </script>
    <?php
    }



    function ce_exportElement($EID){
            $Element = get_option($EID);            
            $Data = base64_encode(serialize($Element));
            $fileName = sanitize_file_name(strtolower($Element['_name'])).'.ce';
            header ("Expires: Mon, 21 Nov 1997 05:00:00 GMT");    // Date in the past
            header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
            header ("Cache-Control: no-cache, must-revalidate");  // HTTP/1.1
            header ("Pragma: no-cache");                          // HTTP/1.0
            header('Content-type: application/ce');
            header('Content-Disposition: attachment; filename="'.$fileName.'"');
            print($Data);
            exit;

    }


}

?>